apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
{% if do_backups %}
    backups.opsperator.io/driver: ldap
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
    backups.opsperator.io/secret: {{ ldap_name }}
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ ldap_name }}
  name: {{ ldap_name }}
  namespace: {{ namespace }}
spec:
  podManagementPolicy: OrderedReady
  replicas: {{ ldap_replicas }}
  selector:
    matchLabels:
      name: {{ ldap_name }}
  serviceName: {{ ldap_name }}
  template:
    metadata:
      labels:
        name: {{ ldap_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ ldap_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ ldap_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: AF_DOMAIN
          value: {{ af_domain }}
        - name: ADM_DOMAIN
          value: {{ adm_domain }}
        - name: AM_DOMAIN
          value: {{ am_domain }}
        - name: ARA_DOMAIN
          value: {{ ara_domain }}
        - name: AS_DOMAIN
          value: {{ as_domain }}
        - name: AX_DOMAIN
          value: {{ ax_domain }}
        - name: BBB_DOMAIN
          value: {{ bbb_domain }}
        - name: CD_DOMAIN
          value: {{ cd_domain }}
        - name: CR_DOMAIN
          value: {{ cr_domain }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: DO_ADMIN
          value: "{% if do_wsweet %}true{% else %}false{% endif %}"
        - name: DO_AIRSONIC
          value: "{% if do_airsonic %}true{% else %}false{% endif %}"
        - name: DO_ALERTMANAGER
          value: "{% if do_alertmanager %}true{% else %}false{% endif %}"
        - name: DO_ARA
          value: "{% if do_ara %}true{% else %}false{% endif %}"
        - name: DO_ARTIFACTORY
          value: "{% if do_artifactory %}true{% else %}false{% endif %}"
        - name: DO_AWX
          value: "{% if do_awx %}true{% else %}false{% endif %}"
        - name: DO_BLUEMIND
          value: "{% if bluemind_api_token | default(False) %}true{% else %}false{% endif %}"
        - name: DO_CODIMD
          value: "{% if do_codimd %}true{% else %}false{% endif %}"
        - name: DO_CYRUS
          value: "{% if do_cyrus %}true{% else %}false{% endif %}"
        - name: DO_DIASPORA
          value: "{% if do_diaspora %}true{% else %}false{% endif %}"
        - name: DO_DOKUWIKI
          value: "{% if do_dokuwiki %}true{% else %}false{% endif %}"
        - name: DO_DRAW
          value: "{% if do_draw %}true{% else %}false{% endif %}"
        - name: DO_ERRBIT
          value: "{% if do_errbit %}true{% else %}false{% endif %}"
        - name: DO_ESCOMRADE
          value: "{% if do_escomrade %}true{% else %}false{% endif %}"
        - name: DO_ETHERPAD
          value: "{% if do_etherpad %}true{% else %}false{% endif %}"
        - name: DO_EXPORTERS
          value: "{% if do_exporters %}true{% else %}false{% endif %}"
        - name: DO_FUSION
          value: "{% if do_fusion %}true{% else %}false{% endif %}"
        - name: DO_GERRIT
          value: "{% if do_gerrit %}true{% else %}false{% endif %}"
        - name: DO_GITEA
          value: "{% if do_gitea %}true{% else %}false{% endif %}"
        - name: DO_GOGS
          value: "{% if do_gogs %}true{% else %}false{% endif %}"
        - name: DO_GRAFANA
          value: "{% if do_grafana %}true{% else %}false{% endif %}"
        - name: DO_GREENLIGHT
          value: "{% if do_greenlight %}true{% else %}false{% endif %}"
        - name: DO_JENKINS
          value: "{% if do_jenkins %}true{% else %}false{% endif %}"
        - name: DO_JITSI
          value: "{% if do_jitsi %}true{% else %}false{% endif %}"
        - name: DO_KIBANA
          value: "{% if do_kibana %}true{% else %}false{% endif %}"
        - name: DO_KIWIIRC
          value: "{% if do_kiwiirc %}true{% else %}false{% endif %}"
        - name: DO_LEMON
          value: "{% if do_lemon %}true{% else %}false{% endif %}"
        - name: DO_MAILDROP
          value: "{% if do_maildrop %}true{% else %}false{% endif %}"
        - name: DO_MAILHOG
          value: "{% if do_mailhog %}true{% else %}false{% endif %}"
        - name: DO_MASTODON
          value: "{% if do_mastodon %}true{% else %}false{% endif %}"
        - name: DO_MATOMO
          value: "{% if do_matomo %}true{% else %}false{% endif %}"
        - name: DO_MATTERMOST
          value: "{% if do_mattermost %}true{% else %}false{% endif %}"
        - name: DO_MEDUSA
          value: "{% if do_medusa %}true{% else %}false{% endif %}"
        - name: DO_MINIO
          value: "{% if do_minio %}true{% else %}false{% endif %}"
        - name: DO_MINIOCONSOLE
          value: "{% if do_minioconsole %}true{% else %}false{% endif %}"
        - name: DO_MUNIN
          value: "{% if do_munin %}true{% else %}false{% endif %}"
        - name: DO_NEXTCLOUD
          value: "{% if do_nextcloud %}true{% else %}false{% endif %}"
        - name: DO_NEXUS
          value: "{% if do_nexus %}true{% else %}false{% endif %}"
        - name: DO_NEWZNAB
          value: "{% if do_newznab %}true{% else %}false{% endif %}"
        - name: DO_PEERTUBE
          value: "{% if do_peertube %}true{% else %}false{% endif %}"
        - name: DO_PHPLDAPADMIN
          value: "{% if do_phpldapadmin %}true{% else %}false{% endif %}"
        - name: DO_POSTFIX
          value: "{% if do_postfix %}true{% else %}false{% endif %}"
        - name: DO_PROMETHEUS
          value: "{% if do_prometheus %}true{% else %}false{% endif %}"
        - name: DO_REGISTRYCONSOLE
          value: "{% if do_registryconsole %}true{% else %}false{% endif %}"
        - name: DO_RELEASEBELL
          value: "{% if do_releasebell %}true{% else %}false{% endif %}"
        - name: DO_ROCKET
          value: "{% if do_rocket %}true{% else %}false{% endif %}"
        - name: DO_ROUNDCUBE
          value: "{% if do_roundcube %}true{% else %}false{% endif %}"
        - name: DO_RSPAMD
          value: "{% if do_rspamd %}true{% else %}false{% endif %}"
        - name: DO_SABNZBD
          value: "{% if do_sabnzbd %}true{% else %}false{% endif %}"
        - name: DO_SERVICEDESK
          value: "{% if do_servicedesk %}true{% else %}false{% endif %}"
        - name: DO_SOGO
          value: "{% if do_sogo %}true{% else %}false{% endif %}"
        - name: DO_SONARQUBE
          value: "{% if do_sonarqube %}true{% else %}false{% endif %}"
        - name: DO_SOPLANNING
          value: "{% if do_soplanning %}true{% else %}false{% endif %}"
        - name: DO_SSP
          value: "{% if do_ssp %}true{% else %}false{% endif %}"
        - name: DO_SYMPA
          value: "{% if do_sympa %}true{% else %}false{% endif %}"
        - name: DO_SYSPASS
          value: "{% if do_syspass %}true{% else %}false{% endif %}"
        - name: DO_THANOS
          value: "{% if do_thanos %}true{% else %}false{% endif %}"
        - name: DO_THANOS_BUCKET
          value: "{% if do_thanos_bucket %}true{% else %}false{% endif %}"
        - name: DO_THANOS_RECEIVE
          value: "{% if do_thanos_receive %}true{% else %}false{% endif %}"
        - name: DO_TINYTINYRSS
          value: "{% if do_tinytinyrss %}true{% else %}false{% endif %}"
        - name: DO_TRANSMISSION
          value: "{% if do_transmission %}true{% else %}false{% endif %}"
        - name: DO_WEKAN
          value: "{% if do_wekan %}true{% else %}false{% endif %}"
        - name: DO_WHITEPAGES
          value: "{% if do_whitepages %}true{% else %}false{% endif %}"
        - name: DO_WORDPRESS
          value: "{% if do_wordpress %}true{% else %}false{% endif %}"
        - name: DO_WSWEET
          value: "{% if do_wsweet %}true{% else %}false{% endif %}"
        - name: DO_ZPUSH
          value: "{% if do_zpush %}true{% else %}false{% endif %}"
        - name: DK_DOMAIN
          value: {{ dk_domain }}
        - name: DR_DOMAIN
          value: {{ dr_domain }}
        - name: DS_DOMAIN
          value: {{ ds_domain }}
        - name: EB_DOMAIN
          value: {{ eb_domain }}
        - name: EC_DOMAIN
          value: {{ ec_domain }}
        - name: EP_DOMAIN
          value: {{ ep_domain }}
        - name: FD_DOMAIN
          value: {{ fd_domain }}
        - name: GF_DOMAIN
          value: {{ gf_domain }}
        - name: GR_DOMAIN
          value: {{ gr_domain }}
        - name: GTA_DOMAIN
          value: {{ gta_domain }}
        - name: GGS_DOMAIN
          value: {{ ggs_domain }}
        - name: JK_DOMAIN
          value: {{ jk_domain }}
        - name: JM_DOMAIN
          value: {{ jm_domain }}
        - name: KB_DOMAIN
          value: {{ kb_domain }}
        - name: KW_DOMAIN
          value: {{ kw_domain }}
        - name: LLNG_APPNAME
          value: {{ lemon_appname }}
        - name: LLNG_BACKGROUND
          value: {{ lemon_background }}
        - name: LLNG_LANG
          value: {{ lang_code }}
{% if lemon_sessions_backend == 'redis' %}
        - name: LLNG_POSTGRES_SESSIONS_DATABASE
          value: ""
        - name: LLNG_POSTGRES_SESSIONS_HOST
          value: ""
        - name: LLNG_POSTGRES_SESSIONS_PASSWORD
          value: ""
        - name: LLNG_POSTGRES_SESSIONS_PORT
          value: ""
        - name: LLNG_POSTGRES_SESSIONS_SSL
          value: ""
        - name: LLNG_POSTGRES_SESSIONS_TABLE
          value: ""
        - name: LLNG_POSTGRES_SESSIONS_USER
          value: ""
        - name: LLNG_REDIS_SESSIONS_DATABASE
          value: "1"
        - name: LLNG_SENTINEL_SESSIONS_HOST
          value: {{ sessions_name }}-client
        - name: LLNG_SENTINEL_SESSIONS_PORT
          value: "26379"
        - name: LLNG_SENTINEL_SESSIONS_REPLICASET
          value: {{ sessions_name }}
        - name: LLNG_SESSIONS_BACKEND
          value: redis
{% elif lemon_sessions_backend == 'postgres' %}
        - name: LLNG_POSTGRES_SESSIONS_DATABASE
           valueFrom:
             secretKeyRef:
               key: database-name
               name: {{ pgsessions_name }}
        - name: LLNG_POSTGRES_SESSIONS_HOST
          value: {{ pgsessions_name }}
        - name: LLNG_POSTGRES_SESSIONS_PASSWORD
           valueFrom:
             secretKeyRef:
               key: database-password
               name: {{ pgsessions_name }}
        - name: LLNG_POSTGRES_SESSIONS_PORT
          value: "5432"
        - name: LLNG_POSTGRES_SESSIONS_SSL
          value: disabled
        - name: LLNG_POSTGRES_SESSIONS_TABLE
          value: sessions
        - name: LLNG_POSTGRES_SESSIONS_USER
           valueFrom:
             secretKeyRef:
               key: database-user
               name: {{ pgsessions_name }}
        - name: LLNG_REDIS_SESSIONS_DATABASE
          value: ""
        - name: LLNG_SENTINEL_SESSIONS_HOST
          value: ""
        - name: LLNG_SENTINEL_SESSIONS_PORT
          value: ""
        - name: LLNG_SENTINEL_SESSIONS_REPLICASET
          value: ""
        - name: LLNG_SESSIONS_BACKEND
          value: postgres
{% else %}
        - name: LLNG_POSTGRES_SESSIONS_DATABASE
          value: ""
        - name: LLNG_POSTGRES_SESSIONS_HOST
          value: ""
        - name: LLNG_POSTGRES_SESSIONS_PASSWORD
          value: ""
        - name: LLNG_POSTGRES_SESSIONS_PORT
          value: ""
        - name: LLNG_POSTGRES_SESSIONS_SSL
          value: ""
        - name: LLNG_POSTGRES_SESSIONS_TABLE
          value: ""
        - name: LLNG_POSTGRES_SESSIONS_USER
          value: ""
        - name: LLNG_REDIS_SESSIONS_DATABASE
          value: ""
        - name: LLNG_SENTINEL_SESSIONS_HOST
          value: ""
        - name: LLNG_SENTINEL_SESSIONS_PORT
          value: ""
        - name: LLNG_SENTINEL_SESSIONS_REPLICASET
          value: ""
        - name: LLNG_SESSIONS_BACKEND
          value: ldap
{% endif %}
        - name: LLNG_SKIN
          value: {{ 'custom' if (lemon_theme_repository_name | default(False)) else lemon_theme }}
        - name: MAIL_DOMAIN
{% if bluemind_api_token | default(False) %}
          valueFrom:
            secretKeyRef:
              key: api-host
              name: {{ bluemind_name }}
{% else %}
          value: {{ mail_domain }}
{% endif %}
        - name: MC_DOMAIN
          value: {{ mc_domain }}
        - name: MD_DOMAIN
          value: {{ md_domain }}
        - name: MDS_DOMAIN
          value: {{ mds_domain }}
        - name: MH_DOMAIN
          value: {{ mh_domain }}
        - name: MI_DOMAIN
          value: {{ mi_domain }}
        - name: MM_DOMAIN
          value: {{ mm_domain }}
        - name: MN_DOMAIN
          value: {{ mn_domain }}
        - name: MO_DOMAIN
          value: {{ mo_domain }}
        - name: MS_DOMAIN
          value: {{ ms_domain }}
        - name: MT_DOMAIN
          value: {{ mt_domain }}
        - name: NC_DOMAIN
          value: {{ nc_domain }}
        - name: NN_DOMAIN
          value: {{ nn_domain }}
        - name: NX_DOMAIN
          value: {{ nx_domain }}
        - name: OIDC_KEY_ID_SIG
          valueFrom:
            secretKeyRef:
              key: lemonldap-oidc-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_ALERTMANAGER_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: alertmanager-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_ARA_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: draw-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_ARA_PASSWORD
          valueFrom:
            secretKeyRef:
              key: ara-password
              name: {{ ldap_name }}
        - name: OPENLDAP_ARTIFACTORY_PASSWORD
          valueFrom:
            secretKeyRef:
              key: artifactory-password
              name: {{ ldap_name }}
        - name: OPENLDAP_AUTHPROXY_PASSWORD
          valueFrom:
            secretKeyRef:
              key: authproxy-password
              name: {{ ldap_name }}
        - name: OPENLDAP_AWX_PASSWORD
          valueFrom:
            secretKeyRef:
              key: awx-password
              name: {{ ldap_name }}
        - name: OPENLDAP_BIND_LDAP_PORT
          value: "1389"
        - name: OPENLDAP_BIND_LDAPS_PORT
          value: "1636"
        - name: OPENLDAP_BLUEMIND_PASSWORD
          valueFrom:
            secretKeyRef:
              key: bluemind-password
              name: {{ ldap_name }}
        - name: OPENLDAP_CODIMD_PASSWORD
          valueFrom:
            secretKeyRef:
              key: codimd-password
              name: {{ ldap_name }}
        - name: OPENLDAP_CYRUS_PASSWORD
          valueFrom:
            secretKeyRef:
              key: cyrus-password
              name: {{ ldap_name }}
        - name: OPENLDAP_DB_BACKEND
          value: {{ ldap_backend }}
        - name: OPENLDAP_DEBUG_LEVEL
          value: "{{ ldap_debug_level }}"
{% if demo_directory | default(False) %}
        - name: OPENLDAP_DEMO_PASSWORD
          valueFrom:
            secretKeyRef:
              key: global-admin-password
              name: {{ ldap_name }}
{% endif %}
        - name: OPENLDAP_DOKUWIKI_PASSWORD
          valueFrom:
            secretKeyRef:
              key: dokuwiki-password
              name: {{ ldap_name }}
        - name: OPENLDAP_DRAW_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: draw-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_ERRBIT_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: errbit-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_ERRBIT_PASSWORD
          valueFrom:
            secretKeyRef:
              key: errbit-password
              name: {{ ldap_name }}
        - name: OPENLDAP_ESCOMRADE_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: escomrade-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_FUSION_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: fusion-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_FUSION_PASSWORD
          valueFrom:
            secretKeyRef:
              key: fusion-password
              name: {{ ldap_name }}
        - name: OPENLDAP_GERRIT_PASSWORD
          valueFrom:
            secretKeyRef:
              key: gerrit-password
              name: {{ ldap_name }}
{% if not (demo_directory | default(False)) %}
        - name: OPENLDAP_GLOBAL_ADMIN_PASSWORD
          valueFrom:
            secretKeyRef:
              key: global-admin-password
              name: {{ ldap_name }}
{% endif %}
        - name: OPENLDAP_GRAFANA_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: grafana-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_GRAFANA_PASSWORD
          valueFrom:
            secretKeyRef:
              key: grafana-password
              name: {{ ldap_name }}
        - name: OPENLDAP_GREENLIGHT_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: greenlight-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_GREENLIGHT_PASSWORD
          valueFrom:
            secretKeyRef:
              key: greenlight-password
              name: {{ ldap_name }}
        - name: OPENLDAP_HOST_ENDPOINT
          value: {{ ldap_name }}
        - name: OPENLDAP_INIT_DEBUG_LEVEL
          value: "{{ ldap_init_debug_level }}"
        - name: OPENLDAP_JENKINS_PASSWORD
          valueFrom:
            secretKeyRef:
              key: jenkins-password
              name: {{ ldap_name }}
        - name: OPENLDAP_JITSI_PASSWORD
          valueFrom:
            secretKeyRef:
              key: jitsi-password
              name: {{ ldap_name }}
        - name: OPENLDAP_KIBANA_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: kibana-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_KIWIIRC_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: kiwiirc-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_LEMONLDAP_HTTPS
          value: yep
        - name: OPENLDAP_LEMONLDAP_PASSWORD
          valueFrom:
            secretKeyRef:
              key: lemonldap-password
              name: {{ ldap_name }}
        - name: OPENLDAP_LEMONLDAP_SESSIONS_PASSWORD
          valueFrom:
            secretKeyRef:
              key: lemonldap-sessions-password
              name: {{ ldap_name }}
        - name: OPENLDAP_LEMON_HTTP_PORT
          value: "8080"
        - name: OPENLDAP_MASTODON_PASSWORD
          valueFrom:
            secretKeyRef:
              key: mastodon-password
              name: {{ ldap_name }}
        - name: OPENLDAP_MATOMO_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: matomo-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_MATOMO_PASSWORD
          valueFrom:
            secretKeyRef:
              key: matomo-password
              name: {{ ldap_name }}
        - name: OPENLDAP_MATTERMOST_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: mattermost-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_MATTERMOST_PASSWORD
          valueFrom:
            secretKeyRef:
              key: mattermost-password
              name: {{ ldap_name }}
        - name: OPENLDAP_MINIO_PASSWORD
          valueFrom:
            secretKeyRef:
              key: minio-password
              name: {{ ldap_name }}
        - name: OPENLDAP_MEDUSA_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: medusa-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_MEDUSA_PASSWORD
          valueFrom:
            secretKeyRef:
              key: medusa-password
              name: {{ ldap_name }}
        - name: OPENLDAP_MONITOR_PASSWORD
          valueFrom:
            secretKeyRef:
              key: monitor-password
              name: {{ ldap_name }}
        - name: OPENLDAP_MUNIN_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: munin-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_MUNIN_PASSWORD
          valueFrom:
            secretKeyRef:
              key: munin-password
              name: {{ ldap_name }}
        - name: OPENLDAP_NEXTCLOUD_PASSWORD
          valueFrom:
            secretKeyRef:
              key: nextcloud-password
              name: {{ ldap_name }}
        - name: OPENLDAP_NEXUS_PASSWORD
          valueFrom:
            secretKeyRef:
              key: nexus-password
              name: {{ ldap_name }}
        - name: OPENLDAP_ORG_SHORT
          value: {{ ldap_org_name }}
        - name: OPENLDAP_PEERTUBE_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: peertube-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_PEERTUBE_PASSWORD
          valueFrom:
            secretKeyRef:
              key: peertube-password
              name: {{ ldap_name }}
        - name: OPENLDAP_PHPLDAPADMIN_PASSWORD
          valueFrom:
            secretKeyRef:
              key: phpldapadmin-password
              name: {{ ldap_name }}
        - name: OPENLDAP_POSTFIX_PASSWORD
          valueFrom:
            secretKeyRef:
              key: postfix-password
              name: {{ ldap_name }}
        - name: OPENLDAP_PROMETHEUS_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: prometheus-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_REGISTRYCONSOLE_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: registryconsole-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_REGISTRYCONSOLE_PASSWORD
          valueFrom:
            secretKeyRef:
              key: registryconsole-password
              name: {{ ldap_name }}
        - name: OPENLDAP_RELEASEBELL_PASSWORD
          valueFrom:
            secretKeyRef:
              key: releasebell-password
              name: {{ ldap_name }}
        - name: OPENLDAP_ROCKET_PASSWORD
          valueFrom:
            secretKeyRef:
              key: rocket-password
              name: {{ ldap_name }}
        - name: OPENLDAP_ROOT_DN_PREFIX
          value: cn=Directory Manager
        - name: OPENLDAP_ROOT_DN_SUFFIX
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_name }}
        - name: OPENLDAP_ROOT_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_ROOT_PASSWORD
          valueFrom:
            secretKeyRef:
              key: root-password
              name: {{ ldap_name }}
        - name: OPENLDAP_SABNZBD_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: sabnzbd-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_SABNZBD_PASSWORD
          valueFrom:
            secretKeyRef:
              key: sabnzbd-password
              name: {{ ldap_name }}
        - name: OPENLDAP_SERVICEDESK_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: servicedesk-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_SERVICEDESK_PASSWORD
          valueFrom:
            secretKeyRef:
              key: servicedesk-password
              name: {{ ldap_name }}
        - name: OPENLDAP_SMTP_SERVER
{% if smtp_relay | default(False) %}
          value: {{ smtp_relay }}
        - name: OPENLDAP_SMTP_PORT
          value: "{{ smtp_port | default('25') }}"
{% elif smtp_address | default(False) %}
          value: {{ smtp_address | urlsplit('hostname') }}
        - name: OPENLDAP_SMTP_PORT
          value: "{{ smtp_address | urlsplit('port') }}"
{% else %}
          value: ""
        - name: OPENLDAP_SMTP_PORT
          value: ""
{% endif %}
        - name: OPENLDAP_SOGO_PASSWORD
          valueFrom:
            secretKeyRef:
              key: sogo-password
              name: {{ ldap_name }}
        - name: OPENLDAP_SONARQUBE_PASSWORD
          valueFrom:
            secretKeyRef:
              key: sonarqube-password
              name: {{ ldap_name }}
        - name: OPENLDAP_SOPLANNING_PASSWORD
          valueFrom:
            secretKeyRef:
              key: soplanning-password
              name: {{ ldap_name }}
        - name: OPENLDAP_SSO_CLIENT_PASSWORD
          valueFrom:
            secretKeyRef:
              key: ssoapp-password
              name: {{ ldap_name }}
        - name: OPENLDAP_SSP_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: ssp-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_SSP_PASSWORD
          valueFrom:
            secretKeyRef:
              key: ssp-password
              name: {{ ldap_name }}
        - name: OPENLDAP_STATEFULSET_NAME
          value: {{ ldap_name }}
        - name: OPENLDAP_SYMPA_PASSWORD
          valueFrom:
            secretKeyRef:
              key: sympa-password
              name: {{ ldap_name }}
        - name: OPENLDAP_SYNCREPL_PASSWORD
          valueFrom:
            secretKeyRef:
              key: syncrepl-password
              name: {{ ldap_name }}
        - name: OPENLDAP_SYSPASS_PASSWORD
          valueFrom:
            secretKeyRef:
              key: syspass-password
              name: {{ ldap_name }}
        - name: OPENLDAP_TINYTINYRSS_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: tinytinyrss-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_TINYTINYRSS_PASSWORD
          valueFrom:
            secretKeyRef:
              key: tinytinyrss-password
              name: {{ ldap_name }}
        - name: OPENLDAP_THANOS_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: thanos-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_THANOSBUCKET_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: thanosbucket-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_THANOSRECEIVE_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: thanosreceive-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_TRANSMISSION_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: transmission-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_WEKAN_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: wekan-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_WEKAN_PASSWORD
          valueFrom:
            secretKeyRef:
              key: wekan-password
              name: {{ ldap_name }}
        - name: OPENLDAP_WHITEPAGES_OAUTH2_SECRET
          valueFrom:
            secretKeyRef:
              key: whitepages-oauth2-secret
              name: {{ ldap_name }}
        - name: OPENLDAP_WHITEPAGES_PASSWORD
          valueFrom:
            secretKeyRef:
              key: whitepages-password
              name: {{ ldap_name }}
        - name: OPENLDAP_WORDPRESS_PASSWORD
          valueFrom:
            secretKeyRef:
              key: wordpress-password
              name: {{ ldap_name }}
        - name: OPENLDAP_WSWEET_PASSWORD
          valueFrom:
            secretKeyRef:
              key: wsweet-password
              name: {{ ldap_name }}
        - name: OPENLDAP_ZPUSH_PASSWORD
          valueFrom:
            secretKeyRef:
              key: zpush-password
              name: {{ ldap_name }}
        - name: PL_DOMAIN
          value: {{ pl_domain }}
        - name: PM_DOMAIN
          value: {{ pm_domain }}
        - name: PT_DOMAIN
          value: {{ pt_domain }}
        - name: RB_DOMAIN
          value: {{ rb_domain }}
        - name: RC_DOMAIN
          value: {{ rc_domain }}
        - name: RESET_SSL
          value: "{{ 'true' if (cert_generated | default(False)) else 'false' }}"
        - name: RG_DOMAIN
          value: {{ rg_domain }}
        - name: RK_DOMAIN
          value: {{ rk_domain }}
        - name: RS_DOMAIN
          value: {{ rs_domain }}
        - name: SB_DOMAIN
          value: {{ sb_domain }}
        - name: SD_DOMAIN
          value: {{ sd_domain }}
        - name: SG_DOMAIN
          value: {{ sg_domain }}
        - name: SM_DOMAIN
          value: {{ sm_domain }}
        - name: SO_DOMAIN
          value: {{ so_domain }}
        - name: SP_DOMAIN
          value: {{ sp_domain }}
        - name: SQ_DOMAIN
          value: {{ sq_domain }}
        - name: SY_DOMAIN
          value: {{ sy_domain }}
        - name: SZ_DOMAIN
          value: {{ sz_domain }}
        - name: TN_DOMAIN
          value: {{ tn_domain }}
        - name: TNB_DOMAIN
          value: {{ tnb_domain }}
        - name: TNR_DOMAIN
          value: {{ tnr_domain }}
        - name: TR_DOMAIN
          value: {{ tr_domain }}
        - name: TX_DOMAIN
          value: {{ tx_domain }}
        - name: TZ
          value: {{ timezone }}
        - name: TZ_DOMAIN
          value: {{ tz_domain }}
        - name: WH_DOMAIN
          value: {{ wh_domain }}
        - name: WK_DOMAIN
          value: {{ wk_domain }}
        - name: WP_DOMAIN
          value: {{ wp_domain }}
        image: {{ (opsimages | json_query("[?name=='ldap'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          initialDelaySeconds: 30
          tcpSocket:
            port: 1389
        name: openldap
        ports:
        - containerPort: 1389
        - containerPort: 1636
        readinessProbe:
          exec:
            command:
            - /bin/sh
            - -i
            - -c
            - /usr/local/bin/is-ready
          initialDelaySeconds: 5
          timeoutSeconds: 2
        resources:
          limits:
            cpu: "{{ ldap_cpu_limit }}"
            memory: "{{ ldap_memory_limit }}"
          requests:
{% if ensure_dbs_has_guaranteed_qosclass | default(True) %}
            cpu: "{{ ldap_cpu_limit }}"
            memory: "{{ ldap_memory_limit }}"
{% else %}
            cpu: "{{ ldap_cpu_request }}"
            memory: "{{ ldap_memory_request }}"
{% endif %}
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /certs/ca.crt
          name: certs
          subPath: ca.crt
{% if do_lemon %}
        - mountPath: /certs/oidc.crt
          name: oidc
          subPath: tls.crt
        - mountPath: /certs/oidc.key
          name: oidc
          subPath: tls.key
        - mountPath: /certs/saml.crt
          name: saml
          subPath: tls.crt
        - mountPath: /certs/saml.key
          name: saml
          subPath: tls.key
{% endif %}
        - mountPath: /certs/tls.crt
          name: certs
          subPath: tls.crt
        - mountPath: /certs/tls.key
          name: certs
          subPath: tls.key
        - mountPath: /etc/ldap
          name: data
          subPath: config
        - mountPath: /etc/openldap
          name: data
          subPath: config
        - mountPath: /run
          name: run
          subPath: run
        - mountPath: /usr/local/openldap/etc/openldap
          name: data
          subPath: config
        - mountPath: /usr/local/openldap/var/log
          name: data
          subPath: logs
        - mountPath: /usr/local/share/ca-certificates
          name: run
          subPath: ca-certificates
        - mountPath: /usr/share/ca-certificates
          name: run
          subPath: empty
        - mountPath: /var/lib/ldap
          name: data
          subPath: db
{% if do_exporters %}
      - env:
        - name: EXPORTER_PORT
          value: "9113"
        - name: LDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_name }}
        - name: LDAP_BIND_DN_PREFIX
          value: cn=monitor,ou=services
        - name: LDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: monitor-password
              name: {{ ldap_name }}
        - name: LDAP_DOMAIN
          value: {{ root_domain }}
        - name: LDAP_HOST
          value: 127.0.0.1
        - name: LDAP_PORT
          value: "1389"
        image: {{ (opsimages | json_query("[?name=='ldapexporter'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          initialDelaySeconds: 30
          periodSeconds: 20
          tcpSocket:
            port: 9113
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_large_cpu_limit }}"
            memory: "{{ exporter_large_memory_limit }}"
          requests:
{% if ensure_dbs_has_guaranteed_qosclass | default(True) %}
            cpu: "{{ exporter_large_cpu_limit }}"
            memory: "{{ exporter_large_memory_limit }}"
{% else %}
            cpu: "{{ exporter_large_cpu_request }}"
            memory: "{{ exporter_large_memory_request }}"
{% endif %}
        securityContext:
          allowPrivilegeEscalation: false
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-database
{% endif %}
{% if rwo_needs_fsgroup | default(False) %}
      securityContext:
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
      terminationGracePeriodSeconds: {{ openldap_termination_timeout | default(600) }}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ ldap_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: certs
        secret:
          secretName: {{ ldap_name }}-tls
{% if do_lemon %}
      - name: oidc
        secret:
          secretName: {{ lemon_name }}-oidc
      - name: saml
        secret:
          secretName: {{ lemon_name }}-saml
{% endif %}
      - emptyDir: {}
        name: run
  updateStrategy:
    type: RollingUpdate
  volumeClaimTemplates:
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
          storage: "{{ ldap_data_volume_capacity }}"
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
